Subject: Re: [2.4 PATCH] bugfix: ARP respond on all devices

From: "David S. Miller" <[email-masked]>
Date: Tue, 19 Aug 2003 11:58:45 -0700

On Tue, 19 Aug 2003 20:00:44 +0100
Richard Underwood <[email-masked]> wrote:

> David S. Miller wrote: 
> > If I know that IP X has my configuration information, I
> > have every right to send X a packet from zero-net to
> > ask for that information before I have any IP addresses
> > attached to the interface.
> > 
> 	Ick! And how is IP X going to get the information back?

It knows the MAC address of the intended receiver, there is
no problem here.

> 	If you are going to send from 0.0.0.0, then I assume there's
> something in the ARP standard to say "don't cache this ARP request" - I must
> have missed it. If so, that's a special case - no need to spoil things
> elsewhere, though.

What is the caching problem?  The ARP response is valid, and we
have no reason to believe otherwise.

> 	Well, what do you do currently? If the packet you're routeing came
> from another host, there's no way in hell you can use their IP address in an
> ARP request ... is there? I certainly hope you don't go that far!!!

We're not talking about routing scenerios, we're talking strictly
about packets being originated by an application on the local host.

> > Besides normal IP addresses, multicast tools use these
> > facilities.
> > 
> 	Multicast uses ARP? That's news to me!

It uses routes that only have been determined only using the desired
device index.  There is no "interface address" to match up to when
we're trying to send to a multicast address.